<?php
/**
 * NOTICE OF LICENSE
 *
 * @author    INVERTUS, UAB www.invertus.eu <support@invertus.eu>
 * @copyright Copyright (c) permanent, INVERTUS, UAB
 * @license   Addons PrestaShop license limitation
 * @see       /LICENSE
 *
 * International Registered Trademark & Property of INVERTUS, UAB
 */

use SwedbankPaymentPortal\SharedEntity\Type\ResponseStatus;
use SwedbankPaymentPortal\SwedbankPaymentPortal;

class SwedBankNotificationModuleFrontController extends ModuleFrontController
{
    const FILENAME = 'notification';
    /**
     * @var SwedBank
     */
    public $module;

    public function checkAccess()
    {
        $secretKey = Tools::getValue('secret_key');
        if (Tools::encrypt($this->module->name) != $secretKey) {
            die;
        }

        return true;
    }

    public function postProcess()
    {
        $xml = Tools::file_get_contents('php://input');

        $environment = Tools::strtoupper($this->module->getEnvironment());
        $debugMode = (bool) Configuration::get('SB_DEBUG_MODE_'.$environment);

        try {
            /** @var SwedbankPaymentPortal $spp */
            $spp = $this->module->get(SwedbankPaymentPortal::class);
            $spp->getBankLinkGateway()->handleNotification($xml);
        } catch (Exception $e) {
            $this->logMessage(
                $debugMode,
                $this->module->l('Notification error', self::FILENAME),
                $e->getMessage()
            );
        }

        echo '<Response>OK</Response>';
        die;
    }

    /**
     * function to log only small portion of data
     * @param $debugMode
     * @param $type
     * @param $message
     */
    private function logMessage($debugMode, $type, $message)
    {
        if (!$debugMode) {
            return;
        }
        $logger = new \Invertus\SwedBank\Service\Logger($this->module);
        $logger->logSimpleData($type, $message);
    }
}
