<?php
/**
 * NOTICE OF LICENSE
 *
 * @author    INVERTUS, UAB www.invertus.eu <support@invertus.eu>
 * @copyright Copyright (c) permanent, INVERTUS, UAB
 * @license   Addons PrestaShop license limitation
 * @see       /LICENSE
 *
 * International Registered Trademark & Property of INVERTUS, UAB
 */

namespace Invertus\SwedBank\Util;

use Cart;
use Currency;
use Customer;

class CartValidation
{
    public function validate(Cart $cart, Customer $customer)
    {
        $currency = new Currency($cart->id_currency);

        if (0 == $cart->id_customer ||
            0 == $cart->id_address_delivery ||
            0 == $cart->id_address_invoice ||
            'EUR' != $currency->iso_code ||
            $customer->id != $cart->id_customer
        ) {
            return false;
        }

        return true;
    }
}
